Bug 789602 - Review Request: codemodel - Java library for code generators
Summary: Review Request: codemodel - Java library for code generators
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
medium
Target Milestone: ---
Assignee: Andy Grimm
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 789599
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-02-11 17:24 UTC by Juan Hernández
Modified: 2016-11-08 03:46 UTC (History)
5 users (show)

Fixed In Version: codemodel-2.6-3.fc17
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-02-15 17:16:42 UTC
Type: ---
agrimm: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Juan Hernández 2012-02-11 17:24:00 UTC
Spec URL:

http://www.xente.mundo-r.com/304027W0001/rpms/codemodel.spec

SRPM URL:

http://www.xente.mundo-r.com/304027W0001/rpms/codemodel-2.6-1.fc17.src.rpm

Description:

CodeModel is a Java library for code generators; it provides a way to
generate Java programs in a way much nicer than PrintStream.println().
This project is a spin-off from the JAXB RI for its schema compiler
to generate Java source files.

Comment 1 Andy Grimm 2012-02-14 15:26:50 UTC
rpmlint on srpm:
codemodel.src: W: invalid-url Source0: codemodel-2.6.tar.gz
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

rpmlint on rpms:
codemodel-javadoc.noarch: W: spelling-error Summary(en_US) Javadocs -> Java docs, Java-docs, Avocados
2 packages and 0 specfiles checked; 0 errors, 1 warnings.

=== REQUIRED ITEMS ===
[x]  Rpmlint output:
[x]  Package is named according to the Package Naming Guidelines[1].
[x]  Spec file name must match the base package name, in the format
%{name}.spec.
[x]  Package meets the Packaging Guidelines.
[x]  Package successfully compiles and builds into binary rpms.
[x]  Buildroot definition is not present
[x]  Package is licensed with an open-source compatible license and meets other
legal requirements as defined in the legal section of Packaging
Guidelines.
[x]  License field in the package spec file matches the actual license.
License type: CDDL or GPLv2
[x]  If (and only if) the source package includes the text of the license(s) in
its own file, then that file, containing the text of the license(s) for the
package is included in %doc.
[x]  All independent sub-packages have license of their own
[x]  Spec file is legible and written in American English.
[x]  Sources used to build the package matches the upstream source, as provided
in the spec URL.
[x]  All build dependencies are listed in BuildRequires, except for any that
are listed in the exceptions section of Packaging Guidelines.
[x]  Package must own all directories that it creates or must require other
packages for directories it uses.
[x]  Package does not contain duplicates in %files.
[x]  File sections do not contain %defattr(-,root,root,-) unless changed with
good reason
[x]  Permissions on files are set properly.
[x]  Package does NOT have a %clean section which contains rm -rf %{buildroot}
(or $RPM_BUILD_ROOT). (not needed anymore)
[x]  Package consistently uses macros (no %{buildroot} and $RPM_BUILD_ROOT
mixing)
[x]  Package contains code, or permissable content.
[-]  Fully versioned dependency in subpackages, if present.
[-]  Package contains a properly installed %{name}.desktop file if it is a GUI
application.
[x]  Package does not own files or directories owned by other packages.
[x]  Javadoc documentation files are generated and included in -javadoc
subpackage
[x]  Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlinks)
[x]  Packages have proper BuildRequires/Requires on jpackage-utils
[x]  Javadoc subpackages have Require: jpackage-utils
[x]  Package uses %global not %define
[x]  If package uses tarball from VCS include comment how to re-create that
tarball (svn export URL, git clone URL, ...)
[!]  If source tarball includes bundled jar/class files these need to be
removed prior to building[1]
[x]  All filenames in rpm packages must be valid UTF-8.
[!]  Jar files are installed to %{_javadir}/%{name}.jar [2]
[x]  If package contains pom.xml files install it (including depmaps) even when
building with ant
[x]  pom files has correct add_maven_depmap

=== Maven ===
[x]  Use %{_mavenpomdir} macro for placing pom files instead of
%{_datadir}/maven2/poms
[-]  If package uses "-Dmaven.test.skip=true" explain why it was needed in a
comment
[-]  If package uses custom depmap "-Dmaven.local.depmap.file=*" explain why
it's needed in a comment
[x]  Package DOES NOT use %update_maven_depmap in %post/%postun
[x]  Packages DOES NOT have Requires(post) and Requires(postun) on
jpackage-utils for %update_maven_depmap macro

=== Other suggestions ===
[x]  If possible use upstream build method (maven/ant/javac)
[x]  Avoid having BuildRequires on exact NVR unless necessary
[x]  Package has BuildArch: noarch (if possible)
[x]  Latest version is packaged.
[x]  Reviewer should test that the package builds in mock.



Issues:
[1] There is a bundled jar: codemodel-2.6/codemodel/lib/package-rename-task.jar
This must be removed prior to the build.

For the guidelines on this, see http://fedoraproject.org/wiki/Packaging:Java#Pre-built_JAR_files_.2F_Other_bundled_software

[2] The final jar names are non-standard.  The names should be EITHER:

/usr/share/java/codemodel-annotation-compiler.jar
/usr/share/java/codemodel.jar

OR

/usr/share/java/codemodel/codemodel-annotation-compiler.jar
/usr/share/java/codemodel/codemodel.jar

If you do not use a subdirectory for your jars, the POM files should be:

/usr/share/maven-poms/JPP-codemodel-annotation-compiler.pom
/usr/share/maven-poms/JPP-codemodel.pom

If you use a subdirectory, they should be:

/usr/share/maven-poms/JPP.codemodel-codemodel-annotation-compiler.pom
/usr/share/maven-poms/JPP.codemodel-codemodel.pom

For the guidelines on this, see http://fedoraproject.org/wiki/Packaging:Java#JAR_file_installation

Comment 2 Juan Hernández 2012-02-14 17:09:26 UTC
Thanks for the comments Andy. An updated spec and SRPM addressing the issues is available here:

http://jhernand.fedorapeople.org/rpms/codemodel/2

Comment 3 Juan Hernández 2012-02-14 19:32:36 UTC
The package failed to build because it was missing the build requirement for maven-surefire-provider-junit4. Fixed, did an scratch build and now works. Find the updated spec and SRPMS here:

http://jhernand.fedorapeople.org/rpms/codemodel/3

Comment 4 Andy Grimm 2012-02-14 20:38:47 UTC
Confirmed that the koji build works, the jar names have been corrected, and the bundled jar has been removed.

APPROVED.

Comment 5 Juan Hernández 2012-02-15 09:35:26 UTC
New Package SCM Request
=======================
Package Name: codemodel
Short Description: Java library for code generators
Owners: jhernand
Branches: f17
InitialCC: goldmann

Comment 6 Gwyn Ciesla 2012-02-15 13:56:13 UTC
Git done (by process-git-requests).

Comment 7 Fedora Update System 2012-03-12 12:57:28 UTC
codemodel-2.6-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/codemodel-2.6-3.fc17

Comment 8 Fedora Update System 2012-03-16 21:25:25 UTC
codemodel-2.6-3.fc17 has been pushed to the Fedora 17 stable repository.


Note You need to log in before you can comment on or make changes to this bug.